class DumpTruck
  class DatabaseConfiguration
    attr_reader :type

    def initialize(type)
      @type = type
      @schemas = {}

      instance_eval(&Proc.new) if block_given?
    end

    def ssh_user(ssh_user = nil)
      @ssh_user = ssh_user || @ssh_user
    end

    def ssh_hostname(ssh_hostname = nil)
      @ssh_hostname = ssh_hostname || @ssh_hostname
    end

    def user(user = nil)
      @user = user || @user
    end

    def password(password = nil)
      @password = password || @password
    end

    def hostname(hostname = nil)
      @hostname = hostname || @hostname
    end

    def schema(name, &block)
      name = name.to_s
      @schemas[name] = SchemaConfiguration.new(name, &block)
    end

    def schemas
      @schemas.values
    end

    def each_schema
      if block_given?
        schemas.each(&Proc.new)
      else
        schemas.each
      end
    end

    def ==(other)
      type = other.type &&
        user == other.user &&
        password == other.password &&
        hostname == other.hostname &&
        schemas == other.schemas
    end

    def to_s
      "<DumpTruck::DatabaseConfiguration(#{type}) (#{schemas.map(&:to_s).join(', ')})>"
    end
  end
end
