class DumpTruck
  class LoggableTruck < Truck
    def initialize(schema_config, client, translator, logger)
      super(schema_config, client, translator)
      @logger = logger
      @processed_rows = 0
    end

  protected

    def extract_tables
      @logger.info("Getting tables from #{schema_config.name.blue}")
      super
    end

    def extract_table(line)
      table = super
      @logger.info("=> #{table.green} in #{schema_config.name.blue}")
      table
    end

    def dump_schema(tables)
      @logger.info("Dumping data from #{schema_config.name.blue}")
      super
      @logger.info("Dumped data from #{schema_config.name.blue}")
    end

    def dump_data(config, table, target)
      @logger.info("=> Dumping #{table.green} in #{schema_config.name.blue}")
      super
      @logger.info("=> Dumped #{@processed_rows.to_s.green} rows from #{table.green} in #{schema_config.name.blue}")
      @processed_rows = 0
    end

    def extract_insert(line)
      fields, data = super
      @processed_rows += data.size
      [fields, data]
    end
  end
end
